<?php
require_once('../../lib/_autoload.php');
require_once('./Constants.php');
require_once('./StorkMessage.php');
$b = new SAML2_HTTPPost();
?>
<html>
<head>
  <title>Demo Service Provider:: (Secure Identity Across Borders Linked)</title>
  <link href="css/estilos.css" rel="stylesheet" type="text/css"/>
</head>

<body>
  <div id="contenedor" class="container">
    <?php include 'header.php'; ?>
	<div id="borde" class="borde">
            <div id="principal" class="contenido">
		<div class="titulo1">
                    <hr class="linea_titulo1">
                        <h2 class="titulo1">
                            <span class="titulo" id="labelTituloActualidadctl00_PlaceHolderMain_labelTituloActualidad">CL@VE-SP</span>
                        </h2>
                    </hr>
		</div>						
		<br/>
		<?php
                    error_reporting(0);
                    //obtener la response
                    $response = $b->receive();
                    //obtener el metadata
                    $authSource = StorkConstants::SPID;
                    $as = SimpleSAML_Auth_Source::getById($authSource);
                    $metadata = $as->getMetadata();
                    try {
                    	//validar la firma
                        $retVal = stork_saml_Message::checkSign($metadata, $response);
			if($retVal) {
                            //obtener las assertions
                            $assertions = $response->getAssertions();
                            //obtener los atributos
                            $attributes = $assertions[0]->getAttributes();
                            //obtener el status de la saml response
                            $status = $response->getStatus();
                            if('urn:oasis:names:tc:SAML:2.0:status:Success' !== $status['Code']) {
                                // Autenticacion fallida!
                                echo '<p>'.$status['Message'].'</p>';
                            } else {
				// Autenticacion correcta!
                                ?>
                                <div class="titulo2">
                                    <h2 class="titulo2">Login realizado con &eacute;xito - <?php echo $response->getIssuer(); ?></h2>
                                </div>
                                <?php
                                    echo '<br /><h2>Requested Data:</h2><br />';
                                    echo '<table class="tabla">';
                                    echo '  <TR class="filatit">';
                                    echo '    <TD>Atributo</TD>';
                                    echo '    <TD>Valores</TD>';
                                    echo '  </TR>';
                                    $keys = array_keys($attributes);
                                    foreach($keys as $key) {
                                        echo '<TR class="filaresult">';
                                        $keyval = array_search($key, StorkConstants::$attrs);
                                        $keyx = explode('.', $keyval);
                                        // Split surname into Apellido1 and Apellido2
                                        if ($keyx[0] == 'Apellidos') {
                                            $surnameURI = StorkConstants::$attrs['Apellidos.uri'];
                                            if ($surnameURI !== false && $attributes[$surnameURI] != null
                                                    && $inheritedFamilyName !== null) {
                                                $surname = $attributes[$surnameURI][0];
                                                $apellido1 = $inheritedFamilyName;
                                                $apellido2 = explode($inheritedFamilyName, $surname)[1];
                                                $apellido2 = str_replace(' ', '', $apellido2);
                                                echo '<TD>Apellido1</TD>';
                                                echo '<TD>'.$apellido1.'</TD>';
                                                echo '</TR>';
                                                echo '<TR class="filaresult">';
                                                echo '<TD>Apellido2</TD>';
                                                echo '<TD>'.$apellido2.'</TD>';
                                            } else {
                                                echo '<TD>'.$keyx[0].'</TD>';
                                                echo '<TD>'.$attributes[$key][0].'</TD>';
                                            }
                                        } else if ($keyx[0] == 'DNI' && isset($_POST['isLegalPerson']) && $_POST['isLegalPerson'] == 'true') {
                                            echo '<TD>'.'CIF'.'</TD>';
                                            echo '<TD>'.$attributes[$key][0].'</TD>';								
                                        } else if ($keyx[0] == 'Nombre' && isset($_POST['isLegalPerson']) && $_POST['isLegalPerson'] == 'true') {
                                            echo '<TD>'.'Raz&oacute;n Social'.'</TD>';
                                            echo '<TD>'.$attributes[$key][0].'</TD>';								
                                        } else {
                                            echo '<TD>'.$keyx[0].'</TD>';
                                            echo '<TD>'.$attributes[$key][0].'</TD>';
                                        }
                                        echo '</TR>';
                                    }
                                    // print all the isLegalPerson stuff
                                    if (isset($_POST['isLegalPerson'])) {
                                        echo '<TR>';
                                        echo '<TD>' . 'Persona Jur&iacute;dica' . '</TD>';					
                                        echo '<TD>' . $_POST['isLegalPerson'] . '</TD>';
                                        echo '<TD> </TD>';
                                        echo '</TR>';
                                        if ($_POST['isLegalPerson'] == 'true' && isset($_POST['oid'])) {
                                            echo '<TR>';
                                            echo '<TD>' . 'OID' . '</TD>';					
                                            echo '<TD>' . $_POST['oid'] . '</TD>';
                                            echo '<TD> </TD>';
                                            echo '</TR>';
                                        }
                                    }
                                    echo '</table>';
                            } 
                        } else {
                            // Validación de firma fallida
                            echo '<h2>Ha ocurrido un error';
                            echo '<p>La validación de la firma ha fallado.</p>';
                        }
                    } catch(Exception $e) {
                       echo '<h2>Ha ocurrido un error';
                       echo '<p>Ha ocurrido una excepci&oacute; en el procesado de la respuesta.</p>';
                    }
                    ?>
                <p>Por favor, haga clic <a href="/SP/">aqu&iacute;</a> para ir a la p&aacute;gina principal.</p>
                <p><a href="/SP/sendLogoutRequest.php">LOGOUT</a></p>
            </div>
            <?php include 'banners.php'; ?>
	</div>
    </div>
    <?php include 'footer.php'; ?>
</body>
</html>
