<?php
require_once('../../lib/_autoload.php');
require_once('./StorkMessage.php');
require_once('./Constants.php');
require_once('./StorkHTTPPost.php');
$b = new SAML2_StorkHTTPPost();
?>
<html>
<head>
    <title>Demo Service Provider:: (Secure Identity Across Borders Linked)</title>
    <link href="css/estilos.css" rel="stylesheet" type="text/css"/>
</head>

<body>
  
	<div id="contenedor" class="container">
  
		<?php include 'header.php'; ?>
		
		<div id="borde" class="borde">
		
			<div id="principal" class="contenido">
			
				<div class="titulo1">
					<hr class="linea_titulo1">
					<h2 class="titulo1">
						<span class="titulo" id="labelTituloActualidadctl00_PlaceHolderMain_labelTituloActualidad">CL@VE-SP</span>
					</h2>
				</div>
									
				<br/>
				
				<?php
					error_reporting(0);
					//obtener la response
					$response = $b->receiveLogout();

					//obtener el metadata
					$authSource = StorkConstants::SPID;
					$as = SimpleSAML_Auth_Source::getById($authSource);
					$metadata = $as->getMetadata();

					try {
						//validar la firma
						$retVal = stork_saml_Message::checkSign($metadata, $response);
						if($retVal) {
							//obtener el status de la saml response
							$status = $response->getStatus();
							if('urn:oasis:names:tc:SAML:2.0:status:Success' !== $status['Code']) {
								// Autenticacion fallida!
				?>
				<div class="titulo2">
					<h2 class="titulo2">ERROR en la respuesta de Logout: <?php echo $status['Message']; ?></h2>
				</div>
				
				<?php 
								echo '<p>Autenticaci&oacute;n fallida: '.$status['Message'].'</p>';
							} else {
								// Autenticacion correcta!
				?>
				<div class="titulo2">
					<h2 class="titulo2">Logout realizado con &eacute;xito</h2>
				</div>
				<?php
							}
							// Validación de firma fallida
						} else {
							echo '<h2>Ha ocurrido un error';
							echo '<p>La validaci&oacute;n de la firma ha fallado.</p>';
						}
					} catch(Exception $e) {
						echo '<h2>Ha ocurrido un error';
						echo '<p>Ha ocurrido una excepci&oacute; en el procesado de la respuesta.</p>';
					}
				?>
				
				<p>Por favor, haga clic <a href="/SP/">aqu&iacute;</a> para ir a la p&aacute;gina principal.</p>
		
			</div>
			
			<?php include 'banners.php'; ?>
			
		</div>
	</div>

	<?php include 'footer.php'; ?>
    
</body>
</html>
