<?php

require_once('../../lib/_autoload.php');
require_once('./Constants.php');
require_once('./StorkMessage.php');
require_once('./StorkHTTPPost.php');
//require_once('../_include.php');

$authSource = StorkConstants::SPID;
$as = new SimpleSAML_Auth_Simple($authSource);
$session = SimpleSAML_Session::getSessionFromRequest();
$returnTo = StorkConstants::LOGOUT_RETURN_URL;
$sendLogoutTo = StorkConstants::LOGOUT_SEND_URL;

try {
    $state = array_merge(array(), array(
        'SimpleSAML_Auth_Default.id' => $authSource,
        'SimpleSAML_Auth_Default.Return' => $returnTo,
        'SimpleSAML_Auth_Default.ErrorURL' => NULL,
        'LogoutCallbackState' => array('SimpleSAML_Auth_Default.logoutSource' => $authSource,),)
    );
	
    $as = SimpleSAML_Auth_Source::getById($authSource);
    $metadata = $as->getMetadata();

    $_POST['spcountry'] = 'ES';
    $_POST['country'] = 'ES';

    $idp = $_POST['spcountry'];
    $idpMetadata = $as->getIdPMetadata($idp);

    $lr = stork_saml_Message::buildLogoutRequestStork($metadata, $idpMetadata, $sendLogoutTo, $returnTo);
    $nameId['Value'] = StorkConstants::SPID;
    $lr->setNameId($nameId);


    $id = SimpleSAML_Auth_State::saveState($state, 'saml:sp:sso', TRUE);
    $lr->setId($id);
	
    $b = new SAML2_StorkHTTPPost($sendLogoutTo, null);
    $b->sendLogout($lr);
} catch(Exception $exception) {
    throw new SimpleSAML_Error_Error('CREATEREQUEST', $exception);
}

